import java.util.*;
import java.io.*;
//import java.lang.Math;

public class GamutSquare extends Document
{

// 		A Gamut Square is made up of:
//		- a Number (int)
//		- a Meter (an int array)
//		- Notes (an Array)
//		- Durations (an Array)
//		- Dynamics (an Array)
//		- Articulations (an Array)
//		- Rest (boolean flag; TRUE = a rest measure) Don't know if we need this, or are rests in note array?
//		- Number of subdivisions for this measure
//		- SYSTEM sets which system the square belongs to, 0 for any
//		- weighting value for probabalistic computations

	Integer	number;
	Integer flipsetNumber;			// shouldn't use this anymore
	int transposition = 0;			// number of steps to transpose each note, can be pos or neg
	double duration = 1;			// value which will be multiplied by each note duration to scale length of phrase
	double length = 0;				// length of entire Gamut Square, sum of all note/chord durations
	int system;						//rkh-12/4/04 - need to make getters and setters and set this in parser
	int weighting;					// rkh-12/08/04 - integer weighting value indicates multiple instances of this cell
									// in the hash-table. If cells are set to not repeat within a selection process, each instance of                                     
									// the cell will be removed from the hash when one is selected. If cells are allowed to repeat, then
									// the cells will remainin the hash-table until all used
	//String meter;
//	int[] meter = new int[2];
    ArrayList meter = new ArrayList();
    ArrayList meterArray = new ArrayList();	// with multiple meters possible, need flexible arraylist
    String metersString = new String();
    //double measureLength;	
    //double[] measureLengths;
    ArrayList measureLengths = new ArrayList();
    
	String keysignature;
	String clef;
	
	String markup = new String();		// markup string i.e. pizz, arco, etc.
	
	Note currentNote;			// temp Note object to hold newly formed note
	int group=0;				//"group" will allow cells to be grouped together based on an integer value
	
	public List Notes;
	public String notesString = new String();
	
	public ArrayList durations = new ArrayList();
	public String durationsString = new String();
	
	public ArrayList durationTypes = new ArrayList();	
	public ArrayList dynamics = new ArrayList();
    public ArrayList articulations = new ArrayList();
	public ArrayList stems = new ArrayList();
	public ArrayList ties = new ArrayList();
		
	// values for activity measurement
	double lastNoteValue=-1.0;
	double activitylevel=0.0;
	int zone=0;
	
//	int lastNoteOctave=0;
    
	/**
	* Public Constructor method
	*
	**/
    public GamutSquare()
    {    
    	this.init();    
    }
    	
    public GamutSquare(boolean debug)
    {    
    	this.setDebug(debug);
    	this.init();    	
    }
    	
	/**
	* Public Constructor method
	*
    *	@param	value	int for GamutSquare number	
	**/
    public GamutSquare(int value)
    {
    	this.setNumber(value);
    	this.init();
    }
    
	/**
	* Public Constructor method
	*
    *	@param	value	int for GamutSquare number	
	**/
    public GamutSquare(boolean debug, int value)
    {
    	this.setDebug(debug);    
    	this.setNumber(value);
    	this.init();
    }    
    
    /**
    *
    * Public method to clear all values for object
    *
    **/
    public void Clear()
    {
    	this.setNumber(0);
    	this.setFlipsetNumber(0); 
    	this.Notes.clear();
    	this.durations.clear();
    	this.durationTypes.clear();
    	this.dynamics.clear();
    	this.articulations.clear();
    	this.stems.clear();
    	this.ties.clear();
		this.setTransposition(0);		
		this.setDuration(1);		
		this.setLength(0);				
		//this.meter = new String();
		this.keysignature = new String();
		this.clef = new String(); 	    	
    }
    	
    /**
    *
    * Private Initalization method
    *
    *	@param	value	int for GamutSquare number
    **/	
    private void init(int value)
    {
    	this.setNumber(value);
    }  
    
    private void init()
    {
    	Notes = new ArrayList();
		buildPitchHashtable();		// builds hashtable of notes and note number for activity measurement in calculateActivity()
    }
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	String number of the Gamut square.
  	**/
	public void setNumber(int value)
	{
		this.number = new Integer(value);
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	Integer number of the Gamut square.
  	**/
	public void setNumber(Integer value)
	{
		this.number = value;
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	String number of the Gamut square.
  	**/
	public void setNumber(String value)
	{
		this.number =  new Integer(value);
	}	
		
	/**
	*	Public getter method
	*
	*	@return	String	number of the Gamut square.
	**/
	public Integer getNumber()
	{
		return this.number;
	}	

    /**
  	*	Public setter method
  	*
  	*	@param	value	Group number of the Gamut square.
  	**/
	public void setGroup(int value)
	{
		this.group = value;
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	Group number of the Gamut square.
  	**/
	public void setGroup(Integer value)
	{
		this.group = value.intValue();
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	Group number of the Gamut square.
  	**/
	public void setGroup(String value)
	{
		this.group =  new Integer(value).intValue();
	}	
		
	/**
	*	Public getter method
	*
	*	@return	String	Group of the Gamut square.
	**/
	public int getGroup()
	{
		return this.group;
	}	
	
	/**
	*	Public getter method
	*
	*	@return	int	Roll number of the Gamut square
	**/
	public Integer getFlipsetNumber()
	{
		return this.flipsetNumber;
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	int Roll number of the Gamut square.
  	**/
	public void setFlipsetNumber(int value)
	{
		this.flipsetNumber = new Integer(value);	
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	Integer Roll number of the Gamut square.
  	**/		
	public void setFlipsetNumber(Integer value)
	{
		this.flipsetNumber = value;	
	}

    /**
  	*	Public setter method
  	*
  	*	@param	value	String Roll number of the Gamut square.
  	**/
	public void setFlipsetNumber(String value)
	{
		this.flipsetNumber = new Integer(value);	
	}
	
	/**
	*	Public getter method
	*
	*	@return	int	durational multiplier of the Gamut Square
	**/
	public double getDuration()
	{
		return this.duration;
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	int durational multiplier for the GamutSquare
  	**/	
	public void setDuration(int value)
	{
		this.duration = value;
	}	

	/**
	*	Public getter method
	*
	*	@return	int	transposition of the Gamut Square in 1/2 steps
	**/
	public int getTransposition()
	{
		return this.transposition;
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	int transposition for the GamutSquare in 1/2 steps
  	**/	
	public void setTransposition(int value)
	{
		this.transposition = value;
	}	
	
	/**
	*	Public getter method
	*
	*	@return	double	length of the Gamut Square in beats times the duration multiplier
	**/
	public double getScaledLength()
	{
		return (this.length*this.duration);
	}

	/**
	*	Public getter method
	*
	*	@return	double	length of the Gamut Square in beats
	**/
	public double getLength()
	{
		return this.length;
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	double length for the GamutSquare
  	**/	
	public void setLength(double value)
	{
		this.length = value;
	}
	
	public int getZone()
	{
		return this.zone;
	}
	
	public void setZone(int value)
	{
		this.zone = value;
	}
	
	/**
	*	Public getter method
	*
	*	@return	String	value of the Clef for each note in the square.
	**/
	public String getClef()
	{
		return this.clef;
	}	
		
    /**
  	*	Public setter method
  	*
  	*	@param	value	String Clef value
  	**/
	public void setClef(String value)
	{
		this.clef = value;	
	}
	
	
	/**
	*	Public getter method
	*
	*	@return	String	value of the Key Signature for each note in the square.
	**/
	public String getKeySignature()
	{
		return this.keysignature;
	}	
		
    /**
  	*	Public setter method
  	*
  	*	@param	value	String Key Signature value
  	**/
	public void setKeySignature(String value)
	{
		this.keysignature = new String(value);	
	}
		
    /**
  	*	Public setter method
  	*
  	*	@param	line	List containing discardable first value and String second value for parsing (from GUI)
  	*
    *	Make an ArrayList to hold 2-dimensional arrays of numerator and denominator
    *
  	**/	
	public void setMeter(String value)
	{
		List temp = new ArrayList();
		//String[] tempStringArray  = {"TEMP", value};
		temp.add("TEMP");
		temp.add(value);
		setMeter(temp);
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	line	List containing current line of file to be processed
    *
    *	Make an ArrayList to hold 2-dimensional arrays of numerator and denominator
    *
  	**/	
	public void setMeter(List line)
	{
		// Take entire line where first value is METER and parse out meter values
		int listSize = line.size();

        // format is "3/4", use meter[] array to hold both values and then ArrayList to hold those Arrays
        // multiple meters: "3/4:4/4"
        // if we hit a ":" then start new meter; need to use arraylist here then
        
        // Write value from line(currentNote) to a String, then extract note values from that string
        String lineString = line.get(1).toString();		
        
        this.metersString = lineString;
        
        // Make master ArrayList to be populated with 2 dimensional arrays
//        ArrayList meterArrays = new ArrayList();
                
        // make sure we have a valid meter string
        if(lineString.length() > 0)
        {
            // Get number of characters in String, to step through each one
            int characterCount = lineString.length();
            
            // Check if there are any ":" delimiters in string and get a count of them        
            int meterCount = 1;        
            int tempPosition = lineString.indexOf(COLON);
            
          //  if(tempPosition > -1)	// If we have at least one "COLON" value...
           // {
                //meterCount++;
                    
            // Since we know we have at least one delimiter, count all delimiters here to know how
            // many meters (and therefore measures) we're dealing with in the current GamutSquare
            while(tempPosition>-1)
            {
                if(lineString.indexOf(COLON, tempPosition) > -1)
                {
                    meterCount++;
                    tempPosition = lineString.indexOf(COLON, tempPosition+1);
                }            
            }            
            
            printSystemOut("meterCount here is: " + meterCount);
           // }
            
            // now we have "meterCount" number of separate meters.
            // ----------------------------------------------------
            // init String for character checking
            String tempChar = new String();
            String tempString = new String();            
            
            int currentPosition=0;
            int counter=0;
            

            // Counter for use in tracking which duration value we're using/how many notes processed
            //counter = 0;			
        
            // STEP THROUGH EACH CHARACTER IN THE STRING REPRESENTING THE CURRENT LIST ITEM
            // IF THE CHARACTER IS NOT A SLASH (or colon) WE WILL ADD IT TO OUR TEMP STRING AND MOVE ON TO THE NEXT CHARACTER
            for(int j=0; j<characterCount; j++)
            {
                // Step through String(i) checking for "/". Extract all chars between "/" to a temp 
                // string, then write all to a new String. Evaluate String and write to note object
                tempChar = new Character(lineString.charAt(j)).toString();                                        
    
                // if we're not processing a slash OR a COLON
                if(tempChar.compareToIgnoreCase(SLASH)!=0 && tempChar.compareToIgnoreCase(COLON)!=0) 
                {
                    // Add character to our string
                    tempString = tempString + tempChar;
                }                    
                else if(tempChar.compareToIgnoreCase(SLASH)==0) //|| j==(characterCount-1)) // || tempChar.compareToIgnoreCase(COLON)==0 ) // we've hit slash or colon and we have a tempString value OR we're in the last character and its a SLASH
                {
                    // if we have hit the slash
                    this.meter.add(new Integer(tempString));         
                    //this.meter = new ArrayList();
                    tempString = "";
                }
                
                if(tempChar.compareToIgnoreCase(COLON)==0	|| j==(characterCount-1))// we've hit a COLON or we're on the last character
                {
                    this.meter.add(new Integer(tempString));
                    
                    // Add current int array to ArrayList
                    this.meterArray.add(meter);        
                    printSystemOut("we're adding meter to meterArray: meterArraySize = " + this.meterArray.size());
                    this.meter = new ArrayList();
                                                                                       
                    tempString = "";
                }			
            }
            
            // Step through loop once for each meter we've found to calculate durations
           // for(int mCount=0; mCount<meterCount; mCount++)
           // {  
            // we can derive a measure length for this gamutSquare based on this meter
            // NEED TO HAVE MULTIPLE MEASURE LENGTHS PER GAMUT SQUARE
            this.setMeasureLength(meterCount);      
           // }
                
                                                       
        }	// if lineString.length>0
        else
        {
            // need to trap error for no meter or use last meter here???
        }       
        
                                      
	}
	
	public String getMeterString(int meterNumber)
	{
		return new String(getMeterNumerator(meterNumber) + "/" +getMeterDenominator(meterNumber));		
	}
	
    public int getMeterNumerator(int meterNumber)
    {
        //int[] tempMeter = this.meterArray.get(meterNumber);
        //return tempMeter[0];
        Integer temp = (Integer)((ArrayList)this.meterArray.get(meterNumber)).get(0);
        return temp.intValue();
        
    }
    
    public int getMeterDenominator(int meterNumber)
    {
//        int[] tempMeter = this.meterArray.get(meterNumber);
//        return tempMeter[1];
        Integer temp = (Integer)((ArrayList)this.meterArray.get(meterNumber)).get(1);
        return temp.intValue();
    }    
	
    private void setMeasureLength(int measureNumber)
    {
        // derive double length in beats for measure
//        int numerator = this.meter[0];
//        int denominator = this.meter[1];
        Integer temp;
        
        for(int i=0; i<measureNumber; i++)
        {
            temp = (Integer)((ArrayList)this.meterArray.get(i)).get(0);
        
            int numerator = temp.intValue();
        
            temp = (Integer)((ArrayList)this.meterArray.get(i)).get(1);
                
            int denominator = temp.intValue();
        
        // these are the note durations used in setting Note's "duration" values:
        // ----------------------------------------------------------------------
        //        noteDuration = 8;		//"double-whole";
        //        noteDuration = 4;		//"whole";						
        //        noteDuration = 2;		//"half";						
        //        noteDuration = 1;		//"quarter";						
        //        noteDuration = .5;	//"eighth";						
        //        noteDuration = .25;	//"sixteenth";						
        //        noteDuration = .125;	//"thirty-second";		

            // final value is set in terms of 1/4 note (note: do we lose precision b/c of the ints? need to convert?)
            this.measureLengths.add(new Double(4*numerator*(1.0/denominator)));
        }
    }
    
    public double getMeasureLength(int measureNumber)
    {
        Double tempDouble = (Double)this.measureLengths.get(measureNumber);
        return tempDouble.doubleValue();
        
        //return (Double)(this.measureLengths.get(measureNumber)).doubleValue();
//        return this.measureLengths[measureNumber];
    }
    
	public void setMarkup(String value)
	{
		this.markup = value;
	}
	
	public String getMarkup()
	{
		return this.markup;
	}
	
    public int getMeasureCount()
    {
    	// THIS IS A BUG: is twice VALUE!!!!
		//printSystemOut("GamutSquare.java : getMeasureCount() : meterArray.size() = " + meterArray.size());
        return this.meterArray.size();
    }
    
	/**
	*	Public getter method
	*
	*	@return	int	weighting of the Gamut Square
	**/
	public int getWeighting()
	{
		return this.weighting;
	}
	
    /**
  	*	Public setter method
  	*
  	*	@param	value	int weighting for the GamutSquare
  	**/	
	public void setWeighting(int value)
	{
		this.weighting = value;
	}		
	
	public void setWeighting(Integer value)
	{
		this.weighting = value.intValue();
	}			
	
	public int getNoteCount()
	{
		return this.Notes.size();
	}
	
	public Note getNote(int value)
	{	
		return (Note)Notes.get(value);
	}
	
	public Note getNote(Integer value)
	{	
		return this.getNote(value.intValue());
	}
		
	public int[] setNotes(List line, int currentChordNumber, ArrayList dotArrayList, int currentNoteNumber)
	{
		// Take entire line where first value is NOTES and parse out note values

		int listSize = line.size();
				
		// Start current character number
		int currentChar = 0;
		String tempString = new String();
		boolean endOfItem = false;
		String lineString = new String();				// init String for line parsing	
		
		// STEP THROUGH ALL THE ITEMS IN THE LIST (CAN BE MORE THAN 2) - CAN THIS BE MORE THAN 2 values????? just "NOTES" and Values?
		for(int i=1; i<listSize; i++)
		{
			// Write value from line(currentNote) to a String, then extract note values from that string
			lineString = line.get(i).toString();			
	
			this.notesString = lineString;
			
			// Get number of characters in String, to step through each one
			int characterCount = lineString.length();
			
			// init String for character checking
			String tempChar = new String();

			// Counter for use in tracking which duration value we're using/how many notes processed
            // NOTE: this counter is not an absolute note counter, just relative to the current GSquare!!!
			int counter = 0;			
	
            boolean currentChord=false;

            int chordCounter=0; // THIS NEEDS TO BE PASSED IN
            
			// STEP THROUGH EACH CHARACTER IN THE STRING REPRESENTING THE CURRENT LIST ITEM
			// IF THE CHARACTER IS NOT A SLASH WE WILL ADD IT TO OUR TEMP STRING AND MOVE ON TO THE NEXT CHARACTER
			for(int j=0; j<characterCount; j++)
			{
				// Step through String(i) checking for "/". Extract all chars between "/" to a temp 
				// string, then write all to a new String. Evaluate String and write to note object
				
				tempChar = new Character(lineString.charAt(j)).toString();				
								
				// IF WE HIT A "/" THAT MEANS WE ARE FINISHED WITH THE CURRENT LIST ITEM
				
				// if we're not processing a slash OR a COLON (for chords)
				if(tempChar.compareToIgnoreCase(SLASH) !=0 && tempChar.compareToIgnoreCase(COLON) !=0) 
				{
					// Add character to our string
					tempString = tempString + tempChar;                    
				}
				else // WE'VE HIT A SLASH OR COLON AND IT IS TIME TO NOW PROCESS THE RESULTANT STRING
				{	
                    
                    if(tempChar.compareToIgnoreCase(COLON)==0)
                    {
                        currentChord=true;
                        
                        chordCounter++;
                        
                        if(chordCounter==1)
                        {
                            currentChordNumber++;
                        }
                    }
                    else
                    {
                        if(currentChord)
                        {
                            chordCounter++;
                        }                                        
                    }

                    
					if(tempString.length()>0)
					{
						// if char is "A, B, C, D, E, F, G, R" (case-insensitive) then setNoteValue
                        if(isNote(tempString))
						{							
							// if note is a rest, set the isRest boolean in the note object
							if(tempString.compareToIgnoreCase(RESTVALUE) == 0)
							{	// should call this method make rest or put in regular makeNote
								this.makeNote(counter, tempString, true, false, dotArrayList, currentNoteNumber);						
							}
							else
							{
                                if(currentChord)
                                {
                                   this.makeNote(counter, tempString, false, true, currentChordNumber, chordCounter, dotArrayList, currentNoteNumber);
                                    
                                    // if current Char is a "/" then increment currentChordNumber
                                    if(tempChar.compareToIgnoreCase(SLASH)==0)
                                    {
                                        currentChord=false;
                                        chordCounter = 0;
                                    }
                                }
                                else
                                {
                                    this.makeNote(counter, tempString, false, false, dotArrayList, currentNoteNumber);
                                }
                            
							}
															
							tempString = "";
                            
                            // Don't increment counter for notes in a chord (to use same duration index from duration table)
                            if(!currentChord)
							{
                                counter++;	//local
                                currentNoteNumber++;//global
                            }
							
						}
						else if(isAccidental(tempString))
						{
							// if char is "s, f, n, ss, ff, (x" then setAccidental (NOTE: multiple chars)
							//printSystemOut("isAccidental: " + tempString);
							//
							//this.debug(bDebug, "setNotes", tempString);
						}
						// if char is "tr, ba, a1, te"
						else if(isClef(tempString))
						{
							this.clef = tempString;
						}
						else if(isKeySignature(tempString))
						{										
							// if char is "K1S, K2S... K1F, K2F...
							this.keysignature = tempString;
						}					
	//					else
	//					{
	//					// if char is Q+, Q-, Q0 then cue note
	//					
	//					} 
	//					else
	//					{
	//					// if char is m, then measure
	//					
	//					}
						// Now set duration and type for this note
						// pull duration from arraylist of (double) durations
						// pull type from arraylist of (String) types
					}
					else
					{
						
					}

				}	// END IF NOT SLASH CHARACTER

			} // end characterCount for loop				
			
		}	// end for loop
        
//        need to also return "currentNoteNumber"
        int[] note_chord_Array = {currentNoteNumber, currentChordNumber};
       // return currentChordNumber;
       return note_chord_Array;
       
	}
	
	
	/**
	*
	*	setDurations
	*
	*	Durations will be processed BEFORE notes are processed, then duration values will be extracted from the durations
	* 	ArrayList and used to set each note's durations value
	**/
	public ArrayList setDurations(List line, ArrayList dotArrayList)
	{
		// Take entire line where first value is DURATIONS and parse out note durations:
		// 1) Step through each value, in the list
		// 2) For each value in the list, step through its characters
		// 3) if each character is not a SLASH then add it to the string (should usually just be one value)
		// 4) if it is a slash, take the string and get the corresponding double value
		// 5) add double value to total and to array
        
        // --> if there is a dot or multiple dots on a duration, add 1/2 again the value
        
		int listSize = line.size();			// Get size of Line list
		this.setLength(0);					// make sure length of this object starts at 0
		String lineString;					// String to hold entire line
		String tempChar = new String();		// Character object to hold current char
		
		// duration size of current square and total length for summation for the Gamut Square
		double noteDuration = 0;
		double totalLength = 0;
		String noteType = new String("");					// variable to hold note Type				
		int noteCounter = 0;					// keep track of how many notes have been counted in durations
		
       // ArrayList dotArray = new ArrayList();	// array to hold note numbers that have dots in them
        int currentDotCount = dotArrayList.size();
        
		// Step through each value in the Line list (currently only using the line(1) node which contains all values)
		for(int i=1; i<listSize; i++)
		{		
			// Duration values will be in first node after header
			//String durationValues =  (String)line.get(1);
            
            ArrayList dotValues = new ArrayList();
			
            // Current node value
			lineString = line.get(i).toString();
			
			this.durationsString = lineString;
			
			// Get number of characters in String, to step through each one
			int characterCount = lineString.length();
			
			// init duration value of current note
			noteDuration = 0;
			
			// temp string to hold current value between slashes
			String tempString = new String();
            
            int dotCounter = 0; 
            noteCounter = currentDotCount;
            
			// Step through characters of current line	
			for(int j=0; j<characterCount; j++)
			{
                                
				// Get current character
				tempChar = new Character(lineString.charAt(j)).toString();			
				
				// if the current char is a SLASH (and we're not still on the first char) then take the previous value(s)
				// that were appended and compare them to our duration constants. If match, then set duration total and local values
				if(tempChar.compareToIgnoreCase(SLASH) !=0) //(tempChar.compareToIgnoreCase(SPACE) != 0) && 
				{
                    // check for a dot
                    if(tempChar.compareToIgnoreCase(DOT) ==0)
                    {
                        dotCounter++;                        
                    }
                    else
                    {
                        // if we haven't hit a SLASH then add the current character to our tempString variable
                        tempString = (tempString + tempChar);	// Add character to our string					
                    }
				}
				else	
				{				
					// if our current character is a slash, that means that we're ready to process the values that
					// came between it and the previous slash/start of string
					                 
					// Add length of note to this.length
					if(tempString.compareToIgnoreCase("D")==0)
					{
						noteDuration = 8;
						noteType = "double-whole";
					}				
					else if(tempString.compareToIgnoreCase("W")==0)
					{
						noteDuration = 4;				
						noteType = "whole";						
					}				
					else if(tempString.compareToIgnoreCase("H")==0)
					{
						noteDuration = 2;
						noteType = "half";						
					}
					else if(tempString.compareToIgnoreCase("Q")==0)
					{
						noteDuration = 1;
						noteType = "quarter";						
					}
					else if(tempString.compareToIgnoreCase("E")==0)
					{
						noteDuration = .5;
						noteType = "eighth";						
					}
					else if(tempString.compareToIgnoreCase("S")==0)
					{
						noteDuration = .25;
						noteType = "sixteenth";						
					}
					else if(tempString.compareToIgnoreCase("T")==0)
					{
						noteDuration = .125;
						noteType = "thirty-second";						
					}				
					else
					{
						//printSystemOut("GamutSquare.java : setDurations : Not matching durations with : " + tempString);
					}

                     dotArrayList.add(new Integer(dotCounter));

                     noteCounter++;                        

                    
                    // this is an awful hack, sheer laziness                    
                    if(dotCounter==1)
                    {
                        noteDuration=noteDuration+this.halveValue(noteDuration);
                    }
                    else if(dotCounter==2)
                    {
                        noteDuration=noteDuration + this.halveValue(noteDuration) + this.halveValue(this.halveValue(noteDuration));
                    }
                    else if(dotCounter==3)
                    {
                        noteDuration=noteDuration + this.halveValue(noteDuration) + this.halveValue(this.halveValue(noteDuration)) + this.halveValue(this.halveValue(this.halveValue(noteDuration)));;
                    }
                    else
                    {                    
                    // there is simply no need for this.                    
                    }                    
                    
                    dotCounter = 0; 
                    
					// add noteDuration and noteType to ArrayLists
					this.durations.add(new Double(noteDuration));					
					this.durationTypes.add(noteType);
					
					int sizeofDurations = this.durations.size();
					
					totalLength = this.length + noteDuration;
					
					this.setLength(totalLength);
					
					tempString = new String();
				}
			}
		}
        
        return dotArrayList;
	}
	
    public double halveValue(double value)
    {
        return value/2;
    }
    
	public boolean isSystems(String value)
	{
		boolean returnValue = false;
		
		if(value.compareToIgnoreCase(SYSTEMS) == 0)
		{
			returnValue = true;	
		}
		
		if(returnValue){this.debug(bDebug, "isSystem", value);}
		
		return returnValue;
	}
	
	public boolean isClef(String value)
	{
		boolean returnValue = false;
		
		// NEED TO SEE HOW TO DIFFERENTIATE A1 FROM THE NOTE A1, DOES CLEF ALWAYS COME FIRST??
		
		// if char is "tr, ba, a1, te"
		if((value.compareToIgnoreCase(TREBLE) == 0) || (value.compareToIgnoreCase(BASS) == 0) || (value.compareToIgnoreCase(ALTO) == 0) || (value.compareToIgnoreCase(TENOR) == 0))
		{
			returnValue = true;
		}
				
		if(returnValue){this.debug(bDebug, "isClef", value);}
				
		return returnValue;					
	}

	
	public boolean isKeySignature(String value)
	{
		boolean returnValue = false;
		
		// if char is "K1S, K2S... K1F, K2F...
		if(value.startsWith("K"))
		{
			returnValue = true;
		}
		
		if(returnValue){this.debug(bDebug, "isKeySignature", value);}
				
		return returnValue;					
	}
	
	
	public boolean isRest(String value)
	{
		boolean returnValue = false;
		
		// if char is R then rest		
		if(value.startsWith("R"))
		{
			returnValue = true;
		}
		
		//if(returnValue){this.debug(bDebug, "isRest", value);}
				
		return returnValue;							
	}
	


	public boolean isNote(String value)
	{
		boolean returnValue = false;

		
		Character tempCharacter = new Character(value.charAt(0));			
			
		if(inString(NOTENAMES, tempCharacter.toString()))
		{
			// if char is "A, B, C, D, E, F, G" (case-insensitive) then true
			returnValue = true;
		}

		//if(returnValue){this.debug(bDebug, "isNote", value);}		
		
		return returnValue;					
	}
	
	public boolean isChord(String value)
	{
		boolean returnValue = false;
		int tempLength = value.length();
				
		Character tempCharacter = new Character(value.charAt(0));			
			
		if(inString(value, COLON))
		{
			returnValue = true;
		}
		
		return returnValue;					
	}	
	
	
	public boolean isAccidental(String value)
	{		
		// check for N - natural, b - flat, and # - sharp
		
		boolean returnValue = false;
		
		// NEED TO ADD CHECK FOR DOUBLE SHARP/DOUBLE FLAT, ETC.
		// CAN'T JUST CHECK ONE CHAR, if longer need to check more
		Character tempCharacter = new Character(value.charAt(1));	
							
		if(inString(ACCIDENTALNAMES, tempCharacter.toString()))
		{			
			returnValue = true;
		}
		
		return returnValue;			

	}	

    public void makeNote(int noteNumber, String value, boolean restValue, boolean chordValue, ArrayList dotArrayList, int currentNoteNumber)
    {
        // set chordNumber to 0 for non-chord notes
        this.makeNote(noteNumber, value, restValue, chordValue, 0, 0, dotArrayList, currentNoteNumber);
    }
    
	public void makeNote(int noteNumber, String value, boolean restValue, boolean chordValue, int currentChordNumber, int chordNoteNumber, ArrayList dotArrayList, int currentNoteNumber)    
	{	
            
		Double tempDuration = (Double)this.durations.get(noteNumber);
		String tempType = (String)this.durationTypes.get(noteNumber);
		
        this.currentNote = new Note(value, tempDuration.doubleValue(), tempType);	
        
        // if there is a dot for the current note, set the dot method to the appropriate number
        // dotArray contains dotValues[], [0] = note number, [1]=number of dots
        
        // step through each value in the array
        int arraySize = dotArrayList.size();
        
        ArrayList tempIntArray;
        
        // Here we're matching array values doing a search for a value each time, 
        // if we've got all notes represented in the dotArrayList, we can simply match???
//        for(int i=0; i<arraySize; i++)
//        {
//            tempIntArray = (ArrayList)dotArrayList.get(i);
            
//            printSystemOut("makeNote - noteNumber: " + noteNumber ); 
//            printSystemOut("makeNote - currentNoteNumber: " + currentNoteNumber ); 
                                   
//            tempIntArray = (ArrayList)dotArrayList.get(currentNoteNumber);
                        
//            Integer temp1 = (Integer)tempIntArray.get(0);
//            int tempInt1 = temp1.intValue();
            
//            if(tempInt1==noteNumber)
//            {
//                Integer temp2 = (Integer)tempIntArray.get(1);
                Integer temp2 = (Integer)dotArrayList.get(currentNoteNumber);
                int tempInt2 = temp2.intValue();
//                printSystemOut("makeNote - note Dot value: " + tempInt2);                
                currentNote.setDot(tempInt2);
//            }
//        }
        
        
        
        if(currentChordNumber>0)
        {
            this.currentNote.setChord(true);
            this.currentNote.setChordNumber(currentChordNumber);
            this.currentNote.setChordNoteNumber(chordNoteNumber);
        }
        
        int articulationStart = value.indexOf("(");
        
        //printSystemOut("GamutSquare: articulationStart = " + articulationStart);
        
        if(articulationStart>-1)	// -1 means DNE
        {
        		int articulationEnd = value.indexOf(")") +1;
        		
        		String articulationValue = value.substring(articulationStart, articulationEnd);
        		//printSystemOut(articulationValue);
        		
        		int artLength = articulationValue.length();
        		
        		for(int b=0; b<artLength; b++)
        		{
        			String temp = new Character(articulationValue.charAt(b)).toString();
					
					if(temp.equals(ARTICULATION_STACCATO))// if(temp.equals("."))
        			{
        				this.currentNote.setArticulation(STACCATO);
        			}
        			else if(temp.equals(ARTICULATION_TENUTO))//("_"))
        			{
        				this.currentNote.setArticulation(TENUTO);
        			}
        			else if(temp.equals(ARTICULATION_ACCENT))//(">"))
        			{
        				this.currentNote.setArticulation(ACCENT);
        			}
        		}
        		
        		// Pass on value without articulation string
        		String newValue = value.substring(0,articulationStart);
        		
        		//printSystemOut("GamutSquare: old string = "+value);                
        		//printSystemOut("GamutSquare: new substring = "+newValue);
        		
        		value=newValue;
        }

        if(restValue)
        {
            this.currentNote.setRest(restValue);        
        }
		else
        {            
            // Check to see if there are 2 or 3 chars in this string, 3 means # or b note
            if(value.length()==3)
            {
                // there are more than 2 chars so the second (and maybe 3rd?) is accidental
                this.currentNote.setAccidental(value.charAt(1));

				//printSystemOut("GamutSquare.java : makeNote() : accidental value = " + value.charAt(1));
				//printSystemOut("GamutSquare.java : makeNote() : getAccidental() value = " + this.currentNote.getAccidental());
				
                // Need to check in case there are multiple accidentals "bb" etc.
                this.currentNote.setOctaveNumber(value.charAt(2));

            }
            else if(value.length()>3)
            {
                this.currentNote.setAccidental(value.substring(1,3));

				//printSystemOut("GamutSquare.java : makeNote() : accidental value = " + value.charAt(1));
				//printSystemOut("GamutSquare.java : makeNote() : getAccidental() value = " + this.currentNote.getAccidental());
				
                this.currentNote.setOctaveNumber(value.charAt(3));                                
            }
            else if(value.length()>1)
            {
                // second value should be a number
                this.currentNote.setOctaveNumber(value.charAt(1));
				this.currentNote.setAccidental("0");
            }
        }
		
//		Do Calculations to track "activity" in the cell
//		motion from pitch to pitch is summed (steps) and divided by # of notes
//		rests are counted as a note but not as a pitch
//		chord notes are counted as pitches but not as notes
		String curAccidental="";
		
		if(this.currentNote.getAccidental()!="-1")
				curAccidental=this.currentNote.getAccidental();				

		this.Notes.add(currentNote);	
		
		if(!this.currentNote.getRest())
			this.calculateActivity(this.currentNote.getNoteValue(), this.currentNote.getOctaveNumber(), curAccidental);	
        //return noteNumber;
	}	
	
	private void setActivityLevel(double level)
	{
		this.activitylevel=level;
	}

	public double getActivityLevel()
	{
		return this.activitylevel;
	}
		
	private void calculateActivity(String notevalue, int octavenumber, String accidental)
	{
		printSystemOut("GamutSquare.java : calculateActivity : notevalue = " + notevalue);
		printSystemOut("GamutSquare.java : calculateActivity : octavenumber = " + octavenumber);
		printSystemOut("GamutSquare.java : calculateActivity : accidental = " + accidental);
						
		// check for bb or ## accidentals
		int accidentalStringLength = accidental.length();
		int accidentalSum = 0;
		
		if(accidental!=NULL&&accidentalStringLength!=0)
		{
			Integer accidentalInteger = new Integer(accidental);
			accidentalSum=accidentalSum+accidentalInteger.intValue();
		}
		
		Integer currentNoteValue = (Integer)pitchHashtable.get(notevalue);	

		double curValue = ((octavenumber+1)*12)+currentNoteValue.intValue()+accidentalSum;
		
		printSystemOut("GamutSquare.java : calculateActivity : curValue for note = " + curValue);
		
		if(lastNoteValue<0)	// this is the first note
		{		
			lastNoteValue=curValue;
			this.setActivityLevel(1.0);			
		}
		else
		{
			this.setActivityLevel(this.getActivityLevel()+Math.abs(lastNoteValue-curValue));//*this.getNoteCount()-1);///(this.getNoteCount()-1)); // get Absolute Value?			
			lastNoteValue=curValue;
		}

		printSystemOut("GamutSquare.java : calculateActivity : (double)this.getActivityLevel() = " + this.getActivityLevel());
		
	}
	
	public void write(String outputType)
	{
	
		StringBuffer output;
		
		// Select which output we're using, either XML or SCORE format
		if(outputType.compareToIgnoreCase(SCORE) == 0)
		{
			output = this.writeScore();
		}
		else if(outputType.compareToIgnoreCase(XML) == 0)
		{
			output = this.writeXML();
		}
		
		
	}
	
	public StringBuffer writeScore()
	{
		StringBuffer output = new StringBuffer();
		
		// Get Header info
		
		// Step through Note getting note, duration, etc. values and writing to appropriate lists
		
		return output;
	}
	
	public StringBuffer writeXML()
	{
		StringBuffer output = new StringBuffer();
		
		// Get header data first
		
		// Get Notes
		
		// Get Durations
		
		
		return output;
	}		
					
}
	