import java.util.*;
import java.io.*;
import java.lang.reflect.*;

public class Note
{	
//	public ArrayList Parameters;
//	String Instrument, Start, Duration; 	// These should ideally all be made Integers, 
											// then in Build, do a toString().
											// Do we want to add startTime and duration here???
	String NOTE = new String("NOTE");
	String ACCIDENTAL = new String("ACCIDENTAL");
	String SHARP = new String("#");
    String DOUBLESHARP = new String("x");
    String DOUBLEFLAT = new String("bb");
	String FLAT = new String("b");
	String NATURAL = new String("N");
	String REST = new String("REST");
	
	String XML = new String("XML");	
	String SCORE = new String("SCORE");			
	String AMPLITUDE = new String("AMPLITUDE");		// rkh-12.04.2004
	int start;
	double duration;						// double must be used for duration values (set in GamutSquare)
	double amplitude;						// rkh-12.04.2004 - need setter and getter
	
	String type;							// Note type, i.e. "whole", "half", "quarter"
	int octaveNumber;
	
	String noteValue;
	
    String accidentaltype = new String("null");    
	String accidental = new String("null");	// Sharp or flat; init with null for comparison later
	
    String dynamic;
	String clef;
	String keysignature;
    
	boolean isRest = false;
	boolean isChord = false;
    boolean gsLastNote = false;
    
	ArrayList articulations = new ArrayList();
	
    int dot = 0;
    
	int chordNumber = 0;
    int chordNoteNumber = 0;
    
	int meterNumber;				// set the meter/measure within the GamutSquare to which each note belongs for easy output/measure correlation
	
	
	/**
	*	Private initialization method
	**/
	private void init()
	{
	}

	/**
	*	Public Constructor
	**/
	public Note()
	{
		this.init();
	}
		
	/**
	*	Public Constructor
	*
	*	@param	value		String note value.
	**/
	public Note(String value)
	{
		this.init();
		this.setNoteValue(value);
	}
	
	
	/**
	*	Public Constructor
	*
	*	@param	noteValue		int noteValue.
	*	@param	start			int note start time value.
	*	@param	duration		int note duration time value.		
	**/
//	public Note(String noteValue, int start, double duration)
//	{
//		this.init();
//		this.setNoteValue(noteValue);
//		this.setStart(start);
//		this.setDuration(duration);
//	}	
	
    public Note(String noteValue, double duration, String type)
    {
        this.setNoteValue(noteValue);
        this.setDuration(duration);
        this.setType(type);
    }
    
    
	/**
	*	Public setter method
	*
	*	@param	value		String note value.
	**/	
	public void setNoteValue(String value)
	{
		//this.noteValue = new String(value.charAt(0));
        char tempChar = value.charAt(0);
        String tempString = String.valueOf(tempChar);
//        String tempString = new String(tempChar);
        
        this.noteValue = tempString;
        
	}

	/**
	*	Public setter method
	*
	*	@param	value		String note value.
	**/	
	public void setNoteValue(char value)
	{
        
        this.setNoteValue(String.valueOf(value));
//		Character tempCharacter = new Character(value);
//		this.noteValue = tempCharacter.toString();
	}
	
	/**
	*	Public getter method
	*
	*	@return	noteValue		String note value.
	**/	
	public String getNoteValue()
	{
		return this.noteValue;
	}
	
	/**
	*	Public setter method
	*
	*	@param	value		String note value.
	**/	
	public void setStart(int value)
	{
		this.start = value;
	}

	/**
	*	Public getter method
	*
	*	@return	start		int start value.
	**/	
	public int getStart()
	{
		return this.start;
	}	

	/**
	*	Public setter method
	*
	*	@param	value		char octave number value.
	**/	
	public void setOctaveNumber(char value)
	{
		Character tempCharacter = new Character(value);
		String tempString = tempCharacter.toString();
		Integer tempInteger = new Integer(tempString);
		this.octaveNumber = tempInteger.intValue();
	}
	
	/**
	*	Public setter method
	*
	*	@param	value		String octave number value.
	**/	
	public void setOctaveNumber(String value)
	{
		Integer tempInteger = new Integer(value);
		this.octaveNumber = tempInteger.intValue();
	}
	
	/**
	*	Public setter method
	*
	*	@param	value		String octave number value.
	**/	
	public void setOctaveNumber(int value)
	{
		this.octaveNumber = value;
	}

	/**
	*	Public getter method
	*
	*	@return	octave number		int octave number value.
	**/	
	public int getOctaveNumber()
	{
		return this.octaveNumber;
	}	
		
	/**
	*	Public setter method
	*
	*	@param	value		int duration value.

	public void setDuration(int value)
	{
//		this.duration = new Integer(value).toString();
		
	}
	**/	
	/**
	*	Public setter method
	*
	*	@param	value		Integer duration value.

	public void setDuration(Integer value)
	{
//		this.duration = value.toString();
	}
		**/	
	/**
	*	Public setter method
	*
	*	@param	value		String duration value.

	public void setDuration(String value)
	{
		this.duration = value;
	}
		**/	

	public void setDuration(double value)
	{
	
		this.duration = value;
	}
	
	/**
	*	Public getter method
	*
	*	@return	duration		int duration value.
	**/	
	public double getDuration()
	{
		return this.duration;
	}	

	/**
	*	Public setter method
	*
	*	@param	value		String duration value.
	**/	
	public void setType(String value)
	{
		this.type = value;
	}
		
	/**
	*	Public getter method
	*
	*	@return	type		String note duration type value.
	**/		
	public String getType()
	{
		return this.type;
	}

	/**
	*	Public setter method
	*
	*	@param	value		String accidental value.
	**/	
    // NOTE: NEED TO CHANGE TO STRING TO ALLOW FOR MULTIPLE VALS (##, bb)
	public void setAccidental(char value)
	{
		Character tempCharacter = new Character(value);
		String tempString = tempCharacter.toString();
		
        this.setAccidental(tempString);
//      
//		String result = new String("");
//		
//		if(tempString.compareToIgnoreCase(SHARP) == 0)
//		{
//			result = "1";
  //          this.setAccidentalType("sharp");            
//		}
//		else if(tempString.compareToIgnoreCase(FLAT) == 0)
//		{
//			result = "-1";
  //          this.setAccidentalType("flat");                        
//		}
//		else if(tempString.compareToIgnoreCase(NATURAL) == 0)
//		{
//			result = "0";
//            this.setAccidentalType("natural");                                    
//		}
//		
//		this.accidental = result;
        
	}
	
	/**
	*	Public setter method
	*
	*	@param	value		String accidental value.
	**/	
	public void setAccidental(String value)
	{
		
		String result = new String("");
		
		if(value.compareToIgnoreCase(SHARP) == 0)
		{
			result = "1";
            this.setAccidentalType("sharp");            
		}
		if(value.compareToIgnoreCase(DOUBLESHARP) == 0)
		{
			result = "2";
            this.setAccidentalType("double-sharp");            
		}        
		else if(value.compareToIgnoreCase(FLAT) == 0)
		{
			result = "-1";
            this.setAccidentalType("flat");                        
		}
		else if(value.compareToIgnoreCase(DOUBLEFLAT) == 0)
		{
			result = "-2";
            this.setAccidentalType("flat-flat");                        
		}        
		else if(value.compareToIgnoreCase(NATURAL) == 0)
		{
			result = "0";
            this.setAccidentalType("natural");                                    
		}
		
		this.accidental = result;
	}

	/**
	*	Public getter method
	*
	*	@return	accidental	String accidental value.
	**/	
	public String getAccidental()
	{
		return this.accidental;
	}	
		
	
	/**
	*	Public setter method
	*
	*	@param	value		String accidental value.
	**/	
	public void setAccidentalType(String value)
	{
		this.accidentaltype = value;
	}


	/**
	*	Public getter method
	*
	*	@return	accidental	String accidental value.
	**/	
	public String getAccidentalType()
	{
		return this.accidentaltype;
	}	
		
	/**
	*	Public getter method
	*
	*	@return	String	value of the Clef for each note in the square.
	**/
	public String getClef()
	{
		return this.clef;
	}	
		
    /**
  	*	Public setter method
  	*
  	*	@param	value	String Clef value
  	**/
	public void setClef(String value)
	{
		this.clef = value;	
	}
	
	/**
	*	Public getter method
	*
	*	@return	String	value of the Key Signature for each note in the square.
	**/
	public String getKeySignature()
	{
		return this.keysignature;
	}	
		
    /**
  	*	Public setter method
  	*
  	*	@param	value	String Key Signature value
  	**/
	public void setKeySignature(String value)
	{
		this.keysignature = new String(value);	
	}			

	public void setMeterNumber(int number)
	{
		this.meterNumber=number;
	}
	
	public int getMeterNumber()
	{
		return this.meterNumber;
	}
	
    public void setDynamic(String value)
    {
        this.dynamic = new String(value);
    }
	
    
    public String getDynamic()
    {
        return this.dynamic;
        
        //<notations>
        //	<dynamics placement="below" relative-y="-25" relative-x="-11">
        //	<pp/>
        //</notations>        
    }

	public void setRest(boolean restBoolean)
	{
		this.isRest = restBoolean;
	}
	
	public void setRest(boolean restBoolean, double duration)
	{
		this.isRest = restBoolean;
		this.duration = duration;
	}	
	
	public boolean getRest()
	{
		return this.isRest;
	}	
    
    public void setChord(boolean chordBoolean)
    {
        this.isChord=chordBoolean;
    }
    
    public boolean getChord()
    {
        return this.isChord;
    }
    
    public void setChordNumber(int chordNumber)
    {
        this.chordNumber = chordNumber;
    }
    
    public int getChordNumber()
    {
        return this.chordNumber;
    }

    public void setChordNoteNumber(int chordNoteNumber)
    {
        this.chordNoteNumber = chordNoteNumber;
    }
    
    public int getChordNoteNumber()
    {
        return this.chordNoteNumber;
    }
    
    public void setDot(int value)
    {
        this.dot = value;
    }
    
    public int getDot()
    {
        return this.dot;
    }
    
	/**
	*	Public method to write the output of the note to a String
	*
	*	@return	String	Text representation of the note as a String.
	**/
	public String Write(String outputType)
	{
		StringBuffer result = new StringBuffer();
     	
     	if(outputType.compareToIgnoreCase(SCORE) == 0)
     	{
     		result = this.writeScore();
     	}
     	else if(outputType.compareToIgnoreCase(XML) == 0)
     	{
     		result = this.writeXML();
     	}     	
		
		return result.toString(); 
	}	
	
	/**
	*	Public method to format the note in SCORE format
	*
	*	@return	StringBuffer
	**/
	public StringBuffer writeScore()
	{
		StringBuffer result = new StringBuffer();
		
		//...
		
		return result;			
	}
	
	public StringBuffer writeXML()
	{
		Xml nodewriter = new Xml();

		StringBuffer result = new StringBuffer();
		
		nodewriter.writeTag(this.NOTE, this.noteValue);
				
		return result;					
	}	
	
	public void setArticulation(String value)
	{
		this.articulations.add(value);		
	}
	
	public String getArticulation(int value)
	{
		return (String)this.articulations.get(value);
	}
}