import java.util.*;
import java.io.*;

public class Staff
{
	public int number;	// Staff number
	public double length;	// Number of beats generated so far for the current Staff

    public boolean globalDuration;
    public boolean globalTransposition;
    
    // Array to hold array value's (3 value) for gamutsquare, duration, transposition
	public ArrayList gamutSquares = new ArrayList();   
    public ArrayList measures = new ArrayList();
    
	public Staff(int number)
	{
		this.number = number;
		this.length = 0;
	}
    
	public Staff(int number, boolean gduration, boolean gtransposition)
	{
		this.number = number;
		this.length = 0;
        
        this.globalDuration = gduration;
        this.globalTransposition = gtransposition;
	}

    // duration is a multiplier and transposition is arithmetic			
	public void addGamutSquare(GamutSquare gamutSquare, int duration, int transposition)
	{		
		// Set duration and transposition for our current Gamut Square
//        if(this.globalDuration) then
//        {
            // AHH, this refers to a duration multiplier not a total change
            gamutSquare.setDuration(duration);
            
            // need to also be able to check TYPE field and correlate here
            // or this should be done in the GamutSquare.setDuration (should set type too)
//		}
        
//        if(this.globalTransposition) then
//        {
            gamutSquare.setTransposition(transposition);
//		}
        
		// Add the length of the new square to the Staff length beat-count
		this.addLength(gamutSquare.getScaledLength());
		
		// Add current Gamut Square to our list of squares for this staff with new transposition and duration values
		this.gamutSquares.add(gamutSquare);
	}    
    
	public void addLength(double value)
	{
		this.length = this.length + value;
	}
	
	public double getLength()
	{
		return this.length;	
	}
	
	public int getNumber()
	{
		return this.number;	
	}
	
	// Return the gamut square in the staff with the given number
	public GamutSquare getGamutSquare(int squareNumber)
	{
		return (GamutSquare)this.gamutSquares.get(squareNumber);
	}
	
    public void addMeasure(Measure measure)
    {
        this.measures.add(measure);    
    }
    
    public Measure getMeasure(int value)
    {
        return (Measure)this.measures.get(value);
    }
    
    
}